//+------------------------------------------------------------------+
//|                                       Copyright  2010,Vitya     |
//+------------------------------------------------------------------+
//-------    -----------------------------------------+
#include <stdlib.mqh>                  //  

extern bool TF_M15 = true; //   15  .
extern bool TF_M30 = true; //   30  .
extern bool TF_H1  = true; //   1  .
extern bool TF_H4  = true; //   4-  .
extern bool TF_D1  = true; //    .

extern int N_candels_M15 = 4; //        15   .
extern int N_candels_M30 = 4; //        30   .
extern int N_candels_H1  = 4; //        1  .
extern int N_candels_H4  = 4; //        4-  .
extern int N_candels_D1  = 4; //         .

extern int Candel_size_M15 = 30;  //      N  .
extern int Candel_size_M30 = 50;  //      N  .
extern int Candel_size_H1  = 90;  //      N  .
extern int Candel_size_H4  = 150; //      N  .
extern int Candel_size_D1  = 200; //      N  .

extern double Lots            = 0.1;     //  .
extern double Coeff_mult_lots = 1.5;     //   .
extern int    N_max_lots      = 3;       //      .
extern int    Take_Profit     = 120;     //   .
extern int    Stop_Lose       = 40;      //   .
extern int    Otstup          = 80;      //     Stop_Lose       .  
extern int    Magic           = 12092010; //  12.09.2010 

//---------------------------------------
bool   open_sell    = false;
bool   open_buy     = false;
bool   gbDisabled   = False;           //   
bool   MarketWatch  = True;            //    "Market Watch".
int    Slippage     = 3;               //  
int    NumberOfTry  = 5;               //   
bool   UseSound     = True;            //   
string SoundSuccess = "ok.wav";        //  
string SoundError   = "timeout.wav";   //  
color  clOpenBuy    = LightBlue;       //    
color  clOpenSell   = LightCoral;      //    
color  clDelete      = Yellow;         //    
string NameFileSound = "expert.wav";   //   


//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
int init()
{

	return(0);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
int deinit()
{

	return(0);
}
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
int start()
{
//----------------------- ----------------------------------------------------------------------------------------
    Search_Patterns();
//-----------------------    ,     ---------------------   
    Open_Position();
//-----------------------    ,   .-----------------------------------------
//----------------------   ,              ,-
//----------------------          .-------------------------------
    Close_Positions();    
}
//+-------------------------------------------------------------------+

void Search_Patterns()
{
 //    ,  .
 if(ExistPositions(NULL, -1, Magic, 0) == true) return;
  
  int n,i;
  open_sell=false;
  open_buy =false;
  
  if(TF_M15 == true)
    {
       n=0;
       for(i=1; i<=N_candels_M15; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_M15,i)>iOpen(NULL,PERIOD_M15,i) &&
               (iHigh(NULL,PERIOD_M15,i)-iLow(NULL,PERIOD_M15,i))>Candel_size_M15*Point && 
               iLow(NULL,PERIOD_M15,i)>(iHigh(NULL,PERIOD_M15,i+1)-(iHigh(NULL,PERIOD_M15,i+1)-iLow(NULL,PERIOD_M15,i+1))*0.7)) n++;
         }
       if(n == N_candels_M15) 
         {
           open_sell=true;
           return;
         }
       n=0; 
       for(i=1; i<=N_candels_M15; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_M15,i)<iOpen(NULL,PERIOD_M15,i) &&
               (iHigh(NULL,PERIOD_M15,i)-iLow(NULL,PERIOD_M15,i))>Candel_size_M15*Point && 
               iHigh(NULL,PERIOD_M15,i)<(iLow(NULL,PERIOD_M15,i+1)+(iHigh(NULL,PERIOD_M15,i+1)-iLow(NULL,PERIOD_M15,i+1))*0.7)) n++;

         }
       if(n == N_candels_M15) 
         {
           open_buy=true;
           return;
         }
     }
   
  if(TF_M30 == true)
    {
       n=0;
       for(i=1; i<=N_candels_M30; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_M30,i)>iOpen(NULL,PERIOD_M30,i) &&
               (iHigh(NULL,PERIOD_M30,i)-iLow(NULL,PERIOD_M30,i))>Candel_size_M30*Point && 
               iLow(NULL,PERIOD_M30,i)>(iHigh(NULL,PERIOD_M30,i+1)-(iHigh(NULL,PERIOD_M30,i+1)-iLow(NULL,PERIOD_M30,i+1))*0.7)) n++;
         }
       if(n == N_candels_M30) 
         {
           open_sell=true;
           return;
         }
       n=0; 
       for(i=1; i<=N_candels_M30; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_M30,i)<iOpen(NULL,PERIOD_M30,i) &&
               (iHigh(NULL,PERIOD_M30,i)-iLow(NULL,PERIOD_M30,i))>Candel_size_M30*Point && 
               iHigh(NULL,PERIOD_M30,i)<(iLow(NULL,PERIOD_M30,i+1)+(iHigh(NULL,PERIOD_M30,i+1)-iLow(NULL,PERIOD_M30,i+1))*0.7)) n++;

         }
       if(n == N_candels_M30) 
         {
           open_buy=true;
           return;
         }
     }
  
  if(TF_H1 == true)
    {
       n=0;
       for(i=1; i<=N_candels_H1; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_H1,i)>iOpen(NULL,PERIOD_H1,i) &&
               (iHigh(NULL,PERIOD_H1,i)-iLow(NULL,PERIOD_H1,i))>Candel_size_H1*Point && 
               iLow(NULL,PERIOD_H1,i)>(iHigh(NULL,PERIOD_H1,i+1)-(iHigh(NULL,PERIOD_H1,i+1)-iLow(NULL,PERIOD_H1,i+1))*0.7)) n++;
         }
       if(n == N_candels_H1) 
         {
           open_sell=true;
           return;
         }
       n=0; 
       for(i=1; i<=N_candels_H1; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_H1,i)<iOpen(NULL,PERIOD_H1,i) &&
               (iHigh(NULL,PERIOD_H1,i)-iLow(NULL,PERIOD_H1,i))>Candel_size_H1*Point && 
               iHigh(NULL,PERIOD_H1,i)<(iLow(NULL,PERIOD_H1,i+1)+(iHigh(NULL,PERIOD_H1,i+1)-iLow(NULL,PERIOD_H1,i+1))*0.7)) n++;

         }
       if(n == N_candels_H1) 
         {
           open_buy=true;
           return;
         }
     }

  if(TF_H4 == true)
    {
       n=0;
       for(i=1; i<=N_candels_H4; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_H4,i)>iOpen(NULL,PERIOD_H4,i) &&
               (iHigh(NULL,PERIOD_H4,i)-iLow(NULL,PERIOD_H4,i))>Candel_size_H4*Point && 
               iLow(NULL,PERIOD_H4,i)>(iHigh(NULL,PERIOD_H4,i+1)-(iHigh(NULL,PERIOD_H4,i+1)-iLow(NULL,PERIOD_H4,i+1))*0.7)) n++;
         }
       if(n == N_candels_H4) 
         {
           open_sell=true;
           return;
         }
       n=0; 
       for(i=1; i<=N_candels_H4; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_H4,i)<iOpen(NULL,PERIOD_H4,i) &&
               (iHigh(NULL,PERIOD_H4,i)-iLow(NULL,PERIOD_H4,i))>Candel_size_H4*Point && 
               iHigh(NULL,PERIOD_H4,i)<(iLow(NULL,PERIOD_H4,i+1)+(iHigh(NULL,PERIOD_H4,i+1)-iLow(NULL,PERIOD_H4,i+1))*0.7)) n++;

         }
       if(n == N_candels_H4) 
         {
           open_buy=true;
           return;
         }
     }

  if(TF_D1 == true)
    {
       n=0;
       for(i=1; i<=N_candels_D1; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_D1,i)>iOpen(NULL,PERIOD_D1,i) &&
               (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))>Candel_size_D1*Point && 
               iLow(NULL,PERIOD_D1,i)>(iHigh(NULL,PERIOD_D1,i+1)-(iHigh(NULL,PERIOD_D1,i+1)-iLow(NULL,PERIOD_D1,i+1))*0.7)) n++;
         }
       if(n == N_candels_D1) 
         {
           open_sell=true;
           return;
         }
       n=0; 
       for(i=1; i<=N_candels_D1; i++) 
         {                                                                 //       70% 
           if( iClose(NULL,PERIOD_D1,i)<iOpen(NULL,PERIOD_D1,i) &&
               (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))>Candel_size_D1*Point && 
               iHigh(NULL,PERIOD_D1,i)<(iLow(NULL,PERIOD_D1,i+1)+(iHigh(NULL,PERIOD_D1,i+1)-iLow(NULL,PERIOD_D1,i+1))*0.7)) n++;

         }
       if(n == N_candels_D1) 
         {
           open_buy=true;
           return;
         }
     }
}
//---------------------------------------------------------------------------------------------------------------------------------
void Open_Position()
{
 //        ,  .
 if(ExistOrders(NULL, -1, Magic, 0) == true) return;
 
 int i;
 int Otst;
 
  if(open_buy == true)
    {
      double lots=Lots;
      OpenPosition(NULL, OP_BUY, lots, Ask-Stop_Lose*Point, Ask+Take_Profit*Point, Magic);
      for(i=1; i<N_max_lots; i++)
        {
          lots=lots*Coeff_mult_lots;
          Otst=Stop_Lose+Otstup*i;
          SetOrder(NULL, OP_BUYLIMIT, lots, Ask-Otst*Point, Ask-(Otst+Stop_Lose)*Point, Ask-Otst*Point+Take_Profit*Point, Magic);
        }  
    }

  if(open_sell == true)
    {
      OpenPosition(NULL, OP_SELL, lots, Bid+Stop_Lose*Point, Bid-Take_Profit*Point, Magic);
      for(i=1; i<N_max_lots; i++)
        {
          lots=lots*Coeff_mult_lots;
          Otst=Stop_Lose+Otstup*i;
          SetOrder(NULL, OP_BUYLIMIT, lots, Ask-Otst*Point, Ask-(Otst+Stop_Lose)*Point, Ask-Otst*Point+Take_Profit*Point, Magic);
        }  
    }
}
//---------------------------------------------------------------------------------------------------------------------------------
void Close_Positions()
{
  if(isCloseLastPosByTake(NULL, -1, Magic)
    {
       DeleteOrders(NULL, -1, Magic);//     ,   
    }   
  if(isCloseLastPosByStop(NULL, -1, Magic)
    {
       Search_Patterns();
       if(open_buy==true || open_sell==true)
         {
            DeleteOrders(NULL, -1, Magic);//    ,    ,  ,  
         }   
    }
      
}
//---------------------------------------------------------------------------------------------------------------------------------
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :                                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void DeleteOrders(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int  err, i, it, k=OrdersTotal(), ot;

  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            for (it=1; it<=NumberOfTry; it++) {
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), clDelete);
              if (fd) {
                if (UseSound) PlaySound(SoundSuccess); break;
              } else {
                err=GetLastError();
                if (UseSound) PlaySound(SoundError);
                Print("Error(",err,") delete order ",GetNameOP(ot),": ",ErrorDescription(err),", try ",it);
                Sleep(1000*5);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.05.2008                                                     |
//|   :       .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
bool isCloseLastPosByStop(string sy="", int op=-1, int mn=-1) {
  datetime t;
  double   ocp, osl;
  int      dg, i, j=-1, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (t<OrderCloseTime()) {
                t=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
    if (dg==0) if (StringFind(OrderSymbol(), "JPY")<0) dg=4; else dg=2;
    ocp=NormalizeDouble(OrderClosePrice(), dg);
    osl=NormalizeDouble(OrderStopLoss(), dg);
    if (ocp==osl) return(True);
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.05.2008                                                     |
//|   :       .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
bool isCloseLastPosByTake(string sy="", int op=-1, int mn=-1) {
  datetime t;
  double   ocp, otp;
  int      dg, i, j=-1, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (t<OrderCloseTime()) {
                t=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
    if (dg==0) if (StringFind(OrderSymbol(), "JPY")<0) dg=4; else dg=2;
    ocp=NormalizeDouble(OrderClosePrice(), dg);
    otp=NormalizeDouble(OrderTakeProfit(), dg);
    if (ocp==otp) return(True);
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 10.04.2008                                                     |
//|   :     .                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//|    co -                                                         |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="") {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, co, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(SoundSuccess); break;
    } else {
      err=GetLastError();
      if (UseSound) PlaySound(SoundError);
      if (pa==0 && pb==0) Message("      "+sy);
      //    
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(SoundSuccess); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 13.03.2008                                                     |
//|   :  .                                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void SetOrder(string sy, int op, double ll, double pp,
              double sl=0, double tp=0, int mn=0, datetime ex=0) {
  color    clOpen;
  datetime ot;
  double   pa, pb, mp;
  int      err, it, ticket, msl;
  string   lsComm=WindowExpertName()+" "+GetNameTF(Period());

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL);
  if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (ex>0 && ex<TimeCurrent()) ex=0;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("SetOrder():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, ex, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66);
        if (ExistOrders(sy, op, mn, ot)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
        Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
        continue;
      }
      mp=MarketInfo(sy, MODE_POINT);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if (pa==0 && pb==0) Message("SetOrder():       "+sy);
      Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa,"  Bid=",pb,"  sy=",sy,"  ll=",ll,"  op=",GetNameOP(op),
            "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
      //  
      if (err==130) {
        switch (op) {
          case OP_BUYLIMIT:
            if (pp>pa-msl*mp) pp=pa-msl*mp;
            if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
            if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
            break;
          case OP_BUYSTOP:
            if (pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
            if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
            if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
            break;
          case OP_SELLLIMIT:
            if (pp<pb+msl*mp) pp=pb+msl*mp;
            if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
            if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
            break;
          case OP_SELLSTOP:
            if (pp>pb-msl*mp) pp=pb-msl*mp;
            if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
            if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
            break;
        }
        Print("SetOrder():   ");
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      //    (8)     (141)
      if (err==8 || err==141) Sleep(1000*100);
      if (err==139 || err==140 || err==148) break;
      //    
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      //   
      if (err==147) {
        ex=0; continue;
      }
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                               |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
  bool   fm;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:		     return("UnknownPeriod");
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}






